Index: trunk/kernel/devices/dev_nic.c
===================================================================
--- trunk/kernel/devices/dev_nic.c	(revision 674)
+++ trunk/kernel/devices/dev_nic.c	(revision 683)
@@ -2366,15 +2543,7 @@
                                                  0,         //  length
                                                  TCP_FLAG_SYN | TCP_FLAG_ACK );
-                    // send segment
+                    // set TCP packet length
                     trsp_length = TCP_HEAD_LEN;
-                    do_send     = true;
-
-#if DEBUG_DEV_NIC_TX 
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_DEV_NIC_TX )
-printk("\n[%s] thread[%x,%x] socket[%x,%d] %s / ACCEPT / send SYN-ACK / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid,
-socket_state_str( socket_state ), cycle );
-#endif
+
                     // update socket.state 
                     hal_remote_s32( XPTR( socket_cxy , &socket_ptr->state ),
@@ -2383,16 +2552,19 @@
                     // update socket.tx_nxt
                     hal_remote_s32( XPTR( socket_cxy , &socket_ptr->tx_nxt ),
-                                          TCP_ISS_SERVER + 1 );
-
-                    // reset tx_valid but do not unblock client thread
-                    hal_remote_s32( XPTR( socket_cxy , &socket_ptr->tx_valid ), false );
+                                          CONFIG_SOCK_ISS_SERVER + 1 );
+#if DEBUG_DEV_NIC_TX 
+if( cycle > DEBUG_DEV_NIC_TX )
+printk("\n[%s] socket[%x,%d] %s / ACCEPT / SYN-ACK build\n",
+__FUNCTION__, socket_pid, socket_fdid, socket_state_str(socket_state) );
+#endif
                 }
                 else                     // report error in all other socket states
                 {
-                    // reset tx_valid
-                    hal_remote_s32( XPTR( socket_cxy , &socket_ptr->tx_valid ), false );
-
-                    // report error to TX client thread
-                    dev_nic_unblock_tx_client( socket_xp , CMD_STS_BADSTATE );
+
+#if DEBUG_DEV_NIC_ERROR
+printk("\n[ERROR] in %s : bad state %s for socket[%x,%x] / cycle %d\n",
+__FUNCTION__, socket_state_str(socket_state), socket_pid, socket_fdid, cycle );
+#endif
+                    return CMD_STS_BADSTATE; 
                 }
             }
@@ -2423,36 +2595,24 @@
                     hal_remote_s32( XPTR(socket_cxy , &socket_ptr->tx_nxt), tx_nxt + 1 );
 
-                    // send segment
+                    // set TCP packet length
                     trsp_length = TCP_HEAD_LEN;
-                    do_send     = true;
 
 #if DEBUG_DEV_NIC_TX 
-cycle = (uint32_t)hal_get_cycles();
 if( cycle > DEBUG_DEV_NIC_TX )
-printk("\n[%s] thread[%x,%x] socket[%x,%d] %s / CLOSE / send FIN-ACK / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid,
-socket_state_str( socket_state ), cycle );
-#endif
-                    // reset tx_valid but do not unblock client thread
-                    hal_remote_s32( XPTR( socket_cxy , &socket_ptr->tx_valid ), false );
+printk("\n[%s] socket[%x,%d] %s / CLOSE / FIN-ACK build\n",
+__FUNCTION__, socket_pid, socket_fdid, socket_state_str(socket_state) );
+#endif
                 }
                 else                                 // all other states => signal error
                 {
 
-#if DEBUG_DEV_NIC_TX 
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_DEV_NIC_TX )
-printk("\n[%s] thread[%x,%x] socket[%x,%d] %s / CLOSE / error BADSTATE / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid,
-socket_state_str( socket_state ), cycle );
-#endif
-                    // reset tx_valid
-                    hal_remote_s32( XPTR( socket_cxy , &socket_ptr->tx_valid ), false );
-
-                    // report error 
-                    dev_nic_unblock_tx_client( socket_xp , CMD_STS_BADSTATE );
+#if DEBUG_DEV_NIC_ERROR
+printk("\n[ERROR] in %s : bad state %s for socket[%x,%x] / cycle %d\n",
+__FUNCTION__, socket_state_str(socket_state),  socket_pid, socket_fdid, cycle );
+#endif
+                    return CMD_STS_BADSTATE; 
                 }
             }
-            /////////////////////////////////////
+            //////////////////////////////////
             else if( cmd_type == CMD_TX_SEND )
             {
@@ -2464,13 +2624,11 @@
 
                     // compute actual payload length
-                    nbytes = ( PAYLOAD_MAX_LEN < todo ) ? PAYLOAD_MAX_LEN : todo;
-
-                    // compute TCP segment base in kernel buffer
-                    k_trsp_base = k_buf + ETH_HEAD_LEN + IP_HEAD_LEN;
-
-                    // move payload to k_buf
-                    memcpy( k_trsp_base + TCP_HEAD_LEN,
-                            tx_buf + (len - todo),
-                            nbytes );
+                    nbytes = ( CONFIG_SOCK_PAYLOAD_MAX < todo ) ? 
+                             CONFIG_SOCK_PAYLOAD_MAX : todo;
+
+                    // move payload from remote tx_buf to local kernel buffer
+                    hal_remote_memcpy( XPTR( local_cxy  , k_trsp_base + TCP_HEAD_LEN ),
+                                       XPTR( socket_cxy , tx_buf + (len - todo) ),
+                                       nbytes );
 
                     // build TCP header 
@@ -2486,30 +2644,21 @@
                     hal_remote_s32( XPTR(socket_cxy , &socket_ptr->tx_nxt), tx_nxt + nbytes );
 
-                    // send TCP segment
+                    // set TCP packet length
                     trsp_length = TCP_HEAD_LEN + nbytes;
-                    do_send     = true;
-
-                    if( todo == nbytes )   // last byte sent 
-                    {
-                        // reset tx_valid when last byte has been sent
-                        hal_remote_s32( XPTR(socket_cxy , &socket_ptr->tx_valid), false );
-                    }
 
 #if DEBUG_DEV_NIC_TX 
-cycle = (uint32_t)hal_get_cycles();
 if( cycle > DEBUG_DEV_NIC_TX )
-printk("\n[%s] thread[%x,%x] socket[%x,%d] %s / SEND / "
-"TCP DATA build / payload %d / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid,
-socket_state_str( socket_state ), nbytes, cycle );
+printk("\n[%s] socket[%x,%d] %s / SEND / %d bytes\n",
+__FUNCTION__, socket_pid, socket_fdid, socket_state_str(socket_state), nbytes );
 #endif
                 }
                 else  // all other socket states
                 {
-                    // reset tx_valid
-                    hal_remote_s32( XPTR( socket_cxy , &socket_ptr->tx_valid ), false );
-
-                    // report error to TX client thread
-                    dev_nic_unblock_tx_client( socket_xp , CMD_STS_BADSTATE );
+
+#if DEBUG_DEV_NIC_ERROR
+printk("\n[ERROR] in %s : bad state %s for socket[%x,%x] / cycle %d\n",
+__FUNCTION__, socket_state_str(socket_state), socket_pid, socket_fdid, cycle );
+#endif
+                    return CMD_STS_BADSTATE; 
                 }
             }
@@ -2517,9 +2666,10 @@
             else  // undefined TX command type
             {
-                // reset tx_valid
-                hal_remote_s32( XPTR( socket_cxy , &socket_ptr->tx_valid ), false );
-
-                // report error to TX client thread
-                dev_nic_unblock_tx_client( socket_xp , CMD_STS_BADCMD );
+
+#if DEBUG_DEV_NIC_ERROR
+printk("\n[ERROR] in %s : undefined command type for socket[%x,%x] %s / cycle %d\n",
+__FUNCTION__, socket_pid, socket_fdid, socket_state_str(socket_state), cycle );
+#endif
+                return CMD_STS_BADCMD; 
             }
         }  // end TCP 
@@ -2527,32 +2677,29 @@
     else         // no valid TX command => handle R2T request only
     {
+
+assert( __FUNCTION__ , (socket_type == SOCK_STREAM) , "don't use R2T queue for UDP" );
+ 
         // get one request from R2T queue 
-        remote_buf_get_to_kernel( socket_r2tq_xp , &r2t_flags , 1 );
+        socket_get_r2t_request( socket_r2tq_xp , &r2t_flags );
 
 #if DEBUG_DEV_NIC_TX 
 cycle = (uint32_t)hal_get_cycles();
 if( cycle > DEBUG_DEV_NIC_TX )
-printk("\n[%s] thread[%x,%x] only r2t_valid for socket[%x,%d] / flags %x / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid, r2t_flags, cycle );
-#endif
-
+printk("\n[%s] socket[%x,%d] %s / send only flags %x / no data\n",
+__FUNCTION__, socket_pid, socket_fdid, socket_state_str(socket_state), r2t_flags );
+#endif
         // build TCP header 
         dev_nic_tx_build_tcp_header( k_trsp_base,
                                      socket_xp,
-                                     0,             // payload length
+                                     0,             // no payload
                                      r2t_flags );   // flags
-        // send TCP segment
+        // set protocol
         trsp_protocol = PROTOCOL_TCP;
+
+        // set TCP packet length
         trsp_length   = TCP_HEAD_LEN;
-        do_send       = true;
     }
 
-    // 4. release the lock protecting the socket
-    remote_queuelock_release( socket_lock_xp );
-
-    // return if no packet to send
-    if( do_send == false ) return;
-
-    // 5. build IP header
+    // 3. build IP header
     dev_nic_tx_build_ip_header( k_buf + ETH_HEAD_LEN,
                                 src_ip_addr,
@@ -2561,12 +2708,5 @@
                                 trsp_length );
 
-#if( DEBUG_DEV_NIC_TX & 1)
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_DEV_NIC_TX )
-printk("\n[%s] thread[%x,%x] IP header build / length %d / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, IP_HEAD_LEN + trsp_length , cycle );
-#endif
-
-    // 6. build ETH header
+    // 4. build ETH header
     dev_nic_tx_build_eth_header( k_buf,
                                  (uint8_t)DST_MAC_5,
@@ -2584,43 +2724,39 @@
                                  IP_HEAD_LEN + trsp_length );
 
-#if( DEBUG_DEV_NIC_TX & 1)
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_DEV_NIC_TX )
-printk("\n[%s] thread[%x,%x] ETH header build / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, cycle );
-#endif
-
-    // 7. move packet to NIC_TX queue (blocking function)
-    dev_nic_tx_move_packet( chdev,
-                            k_buf,
-                            ETH_HEAD_LEN + IP_HEAD_LEN + trsp_length );
-
 #if DEBUG_DEV_NIC_TX
 cycle = (uint32_t)hal_get_cycles();
 if( cycle > DEBUG_DEV_NIC_TX )
-printk("\n[%s] thread[%x,%x] for socket[%x,%d] moved packet to NIC_TX / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid, cycle );
-#endif
+printk("\n[%s] exit for socket[%x,%d] / packet build / cycle %d\n",
+__FUNCTION__, socket_pid, socket_fdid, cycle );
+#endif
+
+    // return success and total packet length
+    *total_length = ETH_HEAD_LEN + IP_HEAD_LEN + trsp_length;
+    return CMD_STS_SUCCESS;
 
 }  // end dev_nic_tx_build_packet()
-
 
 /////////////////////////////////////////
 void dev_nic_tx_server( chdev_t * chdev )
 {
-    uint8_t       k_buf[CONFIG_SOCK_PKT_BUF_SIZE];  // buffer for one packet
-
-    xptr_t        queue_root_xp;       // extended pointer on sockets list root
-    xptr_t        queue_lock_xp;       // extended pointer on lock protecting this list
-    xptr_t        socket_xp;           // extended pointer on on registered socket 
-    socket_t    * socket_ptr;
-    cxy_t         socket_cxy;
-    xptr_t        iter_xp;             // iterator for loop on registered sockets
-    xlist_entry_t temp_root;           // root of temporary list of sockets
-    xptr_t        temp_root_xp;        // extended pointer on temporary list of sockets
-    uint32_t      temp_nr;             // number of active registered sockets
-    bool_t        cmd_valid;           // TX command valid in socket descriptor
-    bool_t        r2t_valid;           // valid R2T request in socket descriptor
-
+    uint8_t           k_buf[CONFIG_SOCK_PKT_BUF_SIZE];  // buffer for one packet
+
+    xptr_t            queue_lock_xp;       // extended pointer on lock for sockets list
+    xptr_t            root_xp;             // extended pointer on sockets list root
+    xptr_t            iter_xp;             // iterator for loop on sockets list
+    xptr_t            list_xp;             // extended pointer on socket tx_list field
+    xptr_t            socket_xp;           // extended pointer on found socket 
+    socket_t        * socket_ptr;          // local pointer on found socket
+    cxy_t             socket_cxy;          // found socket cluster identifier
+    xptr_t            socket_lock_xp;      // extented pointer on found socket lock
+    bool_t            cmd_valid;           // TX command valid in socket descriptor
+    bool_t            r2t_valid;           // valid R2T request in socket descriptor
+    uint32_t          sock_type;           // socket type
+    socket_cmd_sts_t  cmd_sts;             // value returned by dev_nic_tx_build_packet()
+    socket_cmd_type_t tx_cmd;              // socket TX command type
+    uint32_t          tx_todo;             // socket number of bytes not sent yet
+    uint32_t          total_length;        // length of the ETH/IP/TCP packet (bytes)
+    bool_t            found;               // one active socket found
+    
     thread_t * this = CURRENT_THREAD;
 
@@ -2638,95 +2774,54 @@
 "illegal chdev type or direction" );
 
-// check thread can yield
-thread_assert_can_yield( this , __FUNCTION__ );
-
-    // build extended pointer on temporary list
-    temp_root_xp = XPTR( local_cxy , &temp_root );
-                                                         
-    // build extended pointer on client sockets queue (lock & root) 
+    // build extended pointers on client sockets queue lock 
     queue_lock_xp = XPTR( local_cxy , &chdev->wait_lock );
-    queue_root_xp = XPTR( local_cxy , &chdev->wait_root );
+
+    // build extended pointers on client sockets queue root and first item 
+    root_xp  = XPTR( local_cxy , &chdev->wait_root );
 
     while( 1 )  // TX server infinite loop
     {
-        // initialize temporary list of registered sockets as empty
-        xlist_root_init( temp_root_xp );
-        temp_nr = 0;
-
         // take the lock protecting the client sockets queue
         remote_busylock_acquire( queue_lock_xp );
 
-        // build temporary list of all registered sockets
-        if( xlist_is_empty( queue_root_xp ) == false )  
+        found = false;
+
+        // scan registered sockets to find one active socket
+        // with a round robin priority between the registered sockets
+        if( xlist_is_empty( root_xp ) == false )  
         {
-            XLIST_FOREACH( queue_root_xp , iter_xp )
+            XLIST_FOREACH( root_xp , iter_xp )
             {
-                // get client socket cluster and local pointer
+                // get client socket cluster and pointers
                 socket_xp  = XLIST_ELEMENT( iter_xp , socket_t , tx_list );
                 socket_ptr = GET_PTR( socket_xp );
                 socket_cxy = GET_CXY( socket_xp );
 
-                // register socket in temporary list
-                xlist_add_last( temp_root_xp , XPTR( socket_cxy , &socket_ptr->tx_temp ));
-                temp_nr++;
-            }
+                // build extended pointer on socket tx_list field
+                list_xp = XPTR( socket_cxy , &socket_ptr->tx_list );
+
+                // get cmd_valid & r2t_valid from socket descriptor
+                cmd_valid = (bool_t)hal_remote_l32( XPTR( socket_cxy , &socket_ptr->tx_valid ));
+
+                // get r2t_valid from socket descriptor
+                r2t_valid = (bool_t)remote_buf_status( XPTR( socket_cxy , &socket_ptr->r2tq ));
+
+                if( cmd_valid || r2t_valid )    // active => move socket, and exit loop
+                {
+                    // move selected socket to last position for round-robin
+                    xlist_unlink( list_xp );
+                    xlist_add_last( root_xp , list_xp );
+
+                    // exit loop
+                    found = true;
+                    break;
+                }
+            }   // end loop on sockets
         }
-
+        
         // release the lock protecting the client sockets queue
         remote_busylock_release( queue_lock_xp );
 
-        if( temp_nr > 0 )
-        {
-            // loop on temporary list
-            XLIST_FOREACH( temp_root_xp , iter_xp )
-            {
-                // get client socket cluster and local pointer
-                socket_xp  = XLIST_ELEMENT( iter_xp , socket_t , tx_temp );
-                socket_ptr = GET_PTR( socket_xp );
-                socket_cxy = GET_CXY( socket_xp );
-
-                // get cmd_valid & t2t_valid from socket descriptor
-                cmd_valid = hal_remote_l32( XPTR( socket_cxy , &socket_ptr->tx_valid ));
-
-                // get r2t_valid from socket descriptor
-                r2t_valid = (bool_t)remote_buf_status( XPTR( socket_cxy , &socket_ptr->r2tq ));
-
-                // test if socket is active
-                if( cmd_valid || r2t_valid )  // active socket 
-                {
-
-#if DEBUG_DEV_NIC_TX
-cycle = (uint32_t)hal_get_cycles();
-pid  = hal_remote_l32( XPTR( socket_cxy , &socket_ptr->pid ));
-fdid = hal_remote_l32( XPTR( socket_cxy , &socket_ptr->fdid ));
-if( cycle > DEBUG_DEV_NIC_TX )
-printk("\n[%s] thread[%x,%x] found socket[%x,%d] / cmd_valid %d / r2t_valid %d / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, fdid, cmd_valid, r2t_valid, cycle );
-#endif
-                    // build and send one packet/segment for this socket
-                    dev_nic_tx_build_packet( cmd_valid,
-                                             r2t_valid,
-                                             socket_xp,
-                                             k_buf,
-                                             chdev );
-#if DEBUG_DEV_NIC_TX
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_DEV_NIC_TX )
-dev_nic_packet_display( true,                // is_tx
-                        this->process->pid,
-                        this->trdid,
-                        cycle,
-                        k_buf );
-#endif
-                }
-                else                          // inactive socket
-                {
-                   temp_nr--;
-                }
-            }  // end loop on temporary list
-        }
-
-        // block & deschedule if no active socket found in current iteration
-        if( temp_nr == 0 )
+        if( found == false ) // block & deschedule if no active socket 
         {
  
@@ -2737,5 +2832,4 @@
 __FUNCTION__, this->process->pid, this->trdid, cycle );
 #endif
-
             // block and deschedule
             thread_block( XPTR( local_cxy , this ) , THREAD_BLOCKED_CLIENT );
@@ -2749,12 +2843,90 @@
 #endif
         }
+        else              // handle active socket request
+        {
+            // avoid warning
+            total_length = 0;
+ 
+            // build extended pointer on socket lock
+            socket_lock_xp = XPTR( socket_cxy , &socket_ptr->lock );
+
+            // take socket lock
+            remote_queuelock_acquire( socket_lock_xp );
+
+#if DEBUG_DEV_NIC_TX
+cycle = (uint32_t)hal_get_cycles();
+pid  = hal_remote_l32( XPTR( socket_cxy , &socket_ptr->pid ));
+fdid = hal_remote_l32( XPTR( socket_cxy , &socket_ptr->fdid ));
+#endif
+
+#if DEBUG_DEV_NIC_TX
+if( cycle > DEBUG_DEV_NIC_TX )
+printk("\n[%s] thread[%x,%x] select socket[%x,%d] / cmd_val %d / r2t_val %d / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, pid, fdid, cmd_valid, r2t_valid, cycle );
+#endif
+            // build one UDP packet / TCP segment 
+            cmd_sts = dev_nic_tx_build_packet( socket_xp,
+                                               k_buf,
+                                               &total_length );
+#if DEBUG_DEV_NIC_TX
+cycle = (uint32_t)hal_get_cycles();
+if( cycle > DEBUG_DEV_NIC_TX )
+printk("\n[%s] thread[%x,%x] for socket[%x,%x] build packet / %d bytes / sts %d / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, pid, fdid, total_length, cmd_sts, cycle );
+#endif
+            // release socket lock
+            remote_queuelock_release( socket_lock_xp );
+
+            if( cmd_sts == CMD_STS_SUCCESS )    // move packet to TX queue
+            {
+                // move packet to NIC_TX queue 
+                dev_nic_tx_move_packet( chdev,
+                                        k_buf,
+                                        total_length );
+#if DEBUG_DEV_NIC_TX
+cycle = (uint32_t)hal_get_cycles();
+if( cycle > DEBUG_DEV_NIC_TX )
+dev_nic_packet_display( pid, fdid, cycle, k_buf );
+#endif
+                // get socket.type, socket.tx_cmd and socket.tx_todo values 
+                tx_cmd    = hal_remote_l32( XPTR( socket_cxy , &socket_ptr->tx_cmd ));
+                tx_todo   = hal_remote_l32( XPTR( socket_cxy , &socket_ptr->tx_todo ));
+                sock_type = hal_remote_l32( XPTR( socket_cxy , &socket_ptr->type ));
+
+                // client signaling depends on command type and socket type
+                if( (tx_cmd == CMD_TX_SEND) &&  (tx_todo == 0) )
+                {
+                    // reset tx_valid for both UDP and TCP
+                    hal_remote_s32( XPTR( socket_cxy , &socket_ptr->tx_valid), false );
+
+                    // unblock client thread for UDP only
+                    if(sock_type == SOCK_DGRAM)
+                    dev_nic_unblock_tx_client( socket_xp , CMD_STS_SUCCESS );
+                }
+                else  // type is CONNECT / ACCEPT / CLOSE 
+                {
+                    // reset tx_valid
+                    hal_remote_s32( XPTR( socket_cxy , &socket_ptr->tx_valid), false );
+                }
+            }
+            else                          // signal error to client thread
+            {
+                // reset tx_valid
+                hal_remote_s32( XPTR( socket_cxy , &socket_ptr->tx_valid), false );
+
+                // unblock tx_client thread
+                dev_nic_unblock_tx_client( socket_xp , cmd_sts );
+            }
+        }   // end active socket handling
     }   // end infinite while loop
 }  // end dev_nic_tx_server()
 
 
-/////////////////////////////////////////////
-void dev_nic_packet_display( bool_t    is_tx,
-                             pid_t     thread_pid,
-                             trdid_t   thread_trdid,
+
+
+
+//////////////////////////////////////////////////
+void dev_nic_packet_display( pid_t     socket_pid,
+                             uint32_t  socket_fdid,
                              uint32_t  cycle,
                              uint8_t * buf )
@@ -2815,20 +2987,12 @@
     remote_busylock_acquire( lock_xp );
 
-    if( is_tx )
-    {
-        nolock_printk("\n*** NIC_TX server thread[%x,%x] send packet / cycle %d\n",
-        thread_pid, thread_trdid, cycle );
-    }
-    else
-    {
-        nolock_printk("\n*** NIC_RX server thread[%x,%x] get packet / cycle %d\n",
-        thread_pid, thread_trdid, cycle );
-    }
-
-    nolock_printk("\n***** ETH header *****\n");
+    nolock_printk("\n***** packet sent by NIC_TX server for socket[%x,%d] / cycle %d\n",
+    socket_pid, socket_fdid, cycle );
+
+    nolock_printk(" ETH header\n");
     nolock_printk(" - dst_mac  [6] = %l\n" , eth_dst_mac );
     nolock_printk(" - src_mac  [6] = %l\n" , eth_src_mac );
     nolock_printk(" - length   [2] = %d\n" , (uint32_t)eth_length );
-    nolock_printk("***** IP  header *****\n");
+    nolock_printk(" IP  header\n");
     nolock_printk(" - version  [1] = %x\n" , (uint32_t)ip_version );
     nolock_printk(" - tos      [1] = %x\n" , (uint32_t)ip_tos );
@@ -2850,5 +3014,5 @@
                                 ((uint16_t)buf[37]     ) ;
 
-        nolock_printk("***** UDP header *****\n");
+        nolock_printk(" UDP header\n");
         nolock_printk(" - src_port [2] = %d\n" , (uint32_t)udp_src_port );
         nolock_printk(" - dst_port [2] = %d\n" , (uint32_t)udp_dst_port );
@@ -2881,5 +3045,5 @@
                                  ((uint16_t)buf[53]     ) ;
 
-        nolock_printk("***** TCP header *****\n");
+        nolock_printk(" TCP header\n");
         nolock_printk(" - src_port [2] = %x\n" , (uint32_t)tcp_src_port );
         nolock_printk(" - dst_port [2] = %x\n" , (uint32_t)tcp_dst_port );
